Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1000)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1001)
@@ -1,3 +1,5 @@
 #include "Mesh.h"
+#include "glInterface.h"
+#include "OcclusionQuery.h"
 #include "GlRenderer.h"
 #include "ViewCellsManager.h"
@@ -9,8 +11,11 @@
 #include "Environment.h"
 
+
 //#define GL_GLEXT_PROTOTYPES
-#include <GL/glext.h>
+
+
 #include <Cg/cg.h>
 #include <Cg/cgGL.h>
+
 
 #include <QVBoxLayout>
@@ -26,21 +31,37 @@
 
 const int depthMapSize = 512;
-static vector<int> sQueries;
+static vector<OcclusionQuery *> sQueries;
 
 GlRendererWidget *rendererWidget = NULL;
 GlDebuggerWidget *debuggerWidget = NULL;
 
-
-#ifdef _WIN32
-PFNGLGENOCCLUSIONQUERIESNVPROC glGenOcclusionQueriesNV;
-PFNGLBEGINOCCLUSIONQUERYNVPROC glBeginOcclusionQueryNV;
-PFNGLENDOCCLUSIONQUERYNVPROC glEndOcclusionQueryNV;
-PFNGLGETOCCLUSIONQUERYUIVNVPROC glGetOcclusionQueryuivNV;
-
-//PFNGLGENQUERIESARBPROC glGenQueriesARB;
-//PFNGLBEGINQUERYARBPROC glBeginQueryARB;
-//PFNGLENDQUERYARBPROC glEndQueryARB;
-//PFNGLGETQUERYUIVARBPROC glGetQueryuivARB;
-#endif
+static bool arbQuerySupport = false;
+static bool nvQuerySupport = false;
+
+
+static void InitExtensions() 
+{
+	GLenum err = glewInit();
+
+	if (GLEW_OK != err) 
+	{
+		// problem: glewInit failed, something is seriously wrong
+		cerr << "Error: " << glewGetErrorString(err) << endl;
+		exit(1);
+	}
+
+	if (GLEW_ARB_occlusion_query) 
+		arbQuerySupport = true;
+	
+	if (GLEW_NV_occlusion_query) 
+		nvQuerySupport = true;
+	
+
+	if  (!arbQuerySupport && !nvQuerySupport)
+	{
+		cout << "I require the GL_ARB_occlusion_query or the GL_NV_occlusion_query OpenGL extension to work.\n";
+		exit(1);
+	}
+}
 
 
@@ -71,5 +92,5 @@
 
   mUseGlLists = true;
-  
+  //mUseGlLists = false;
 }
 
@@ -82,4 +103,7 @@
 	cgDestroyContext(sCgContext);
   cerr<<"done."<<endl;
+   
+  CLEAR_CONTAINER(sQueries);
+  CLEAR_CONTAINER(mOcclusionQueries);
 }
 
@@ -107,4 +131,7 @@
 	  RenderViewCell(dynamic_cast<ViewCell *>(object));
 	  break;
+  case Intersectable::TRANSFORMED_MESH_INSTANCE:
+	  RenderTransformedMeshInstance(dynamic_cast<TransformedMeshInstance *>(object));
+	  break;
   default:
 	cerr<<"Rendering this object not yet implemented\n";
@@ -151,4 +178,39 @@
 }
 
+
+void
+GlRenderer::RenderTransformedMeshInstance(TransformedMeshInstance *mi)
+{
+	// apply world transform before rendering
+	Matrix4x4 m;
+	mi->GetWorldTransform(m);
+
+	glPushMatrix();
+/*
+	cout << "\n*******" << endl;
+	for (int i = 0; i < 16; ++ i)
+		cout << (float *)(m.x)[i] << " ";
+	
+	cout << "\n*******" << endl;
+	for (int i = 0; i < 4; ++ i)
+		for (int j = 0; j < 4; ++ j)
+			cout << m.x[i][j] << " ";
+
+cout << "\n==" << endl;*/
+
+	glMultMatrixf((float *)m.x);
+	GLfloat dummy[16];
+
+	/*glGetFloatv(GL_MODELVIEW_MATRIX, dummy);
+
+	for (int i = 0; i < 16; ++ i)
+		cout << dummy[i] << " ";
+	cout << endl;*/
+	RenderMesh(mi->GetMesh());
+	
+	glPopMatrix();
+}
+
+
 void
 GlRenderer::SetupFalseColor(const int id)
@@ -207,27 +269,7 @@
   glEnable(GL_CULL_FACE);
   
-  glGenOcclusionQueriesNV = (PFNGLGENOCCLUSIONQUERIESNVPROC)
-	wglGetProcAddress("glGenOcclusionQueriesNV");
-  glBeginOcclusionQueryNV = (PFNGLBEGINOCCLUSIONQUERYNVPROC)
-	wglGetProcAddress("glBeginOcclusionQueryNV");
-  glEndOcclusionQueryNV = (PFNGLENDOCCLUSIONQUERYNVPROC)
-	wglGetProcAddress("glEndOcclusionQueryNV");
-  glGetOcclusionQueryuivNV = (PFNGLGETOCCLUSIONQUERYUIVNVPROC)
-	wglGetProcAddress("glGetOcclusionQueryuivNV");
-
-
-#if 0
-  glGenQueriesARB = (PFNGLGENDQUERIESARBPROC)
-	wglGetProcAddress("glGenQueriesARB");
-  glBeginQueryARB = (PFNGLBEGINQUERYARBPROC)
-	wglGetProcAddress("glBeginQueryARB");
-  glEndQueryARB = (PFNGLENDQUERYARBPROC)
-	wglGetProcAddress("glEndQueryARB");
-  glGetQueryuivARB = (PFNGLGETQUERYUIVARBPROC)
-	wglGetProcAddress("glGetQueryuivARB");
-
-#endif
-  
-
+  // HACK!! but using glew keeps crashing for some reason ...
+  InitExtensions();
+  
 #if 0
   GLfloat mat_ambient[]   = {  0.5, 0.5, 0.5, 1.0  };
@@ -445,5 +487,5 @@
 void
 GlRendererBuffer::EvalQueryWithItemBuffer(
-									   //RenderCostSample &sample
+										  //RenderCostSample &sample
 									   )
 {
@@ -470,5 +512,5 @@
 }
 
-std::ofstream outfile("try_100.txt");
+//std::ofstream outfile("try_arb.txt");
 void
 GlRendererBuffer::EvalQueryWithOcclusionQueries(
@@ -483,65 +525,80 @@
 
 	// simulate detectemptyviewspace using backface culling
-	/*if (mDetectEmptyViewSpace) 
+	if (mDetectEmptyViewSpace) 
 	{
 		glEnable(GL_CULL_FACE);
-		cout << "culling" << endl;
+		//cout << "culling" << endl;
 	}
 	else
 	{
-		cout << "not culling" << endl;
+		//cout << "not culling" << endl;
 		glDisable(GL_CULL_FACE);
-	}*/
-
-	
-	const int numQ = 500;//(int)mOcclusionQueries.size();
-	
-//outfile << "\n**************" << endl;
-glFinish();
+	}
+
+	
+	//const int numQ = 1;
+	const int numQ = (int)mOcclusionQueries.size();
+	
+	//glFinish();
+#if 0
 	//-- now issue queries for all objects
 	for (int j = 0; j < (int)mObjects.size(); ++ j) 
+	{
+		mOcclusionQueries[j]->BeginQuery();
+		RenderIntersectable(mObjects[j]);
+		mOcclusionQueries[j]->EndQuery();
+
+		unsigned int pixelCount;
+
+		pixelCount = mOcclusionQueries[j]->GetQueryResult();
+		mObjects[j]->mCounter += pixelCount;
+	}
+#else
+
+	int q = 0;
+
+	//-- now issue queries for all objects
+	for (int j = 0; j < (int)mObjects.size(); j += q) 
 	{	
-		for (int q = 0; ((j + q) < (int)mObjects.size()) && (q < numQ); ++ q) 
+		for (q = 0; ((j + q) < (int)mObjects.size()) && (q < numQ); ++ q) 
 		{
 			//glFinish();
-//			outfile << "queries: " << mOcclusionQueries[q] << " ";
-			glBeginOcclusionQueryNV(mOcclusionQueries[q]);
+			mOcclusionQueries[q]->BeginQuery();
 			
 			RenderIntersectable(mObjects[j + q]);
 		
-			glFlush();
-			glEndOcclusionQueryNV();
+			mOcclusionQueries[q]->EndQuery();
 			//glFinish();
 		}
-
-//		outfile << endl;
+		//cout << "q: " << q << endl;
 		// collect results of the queries
-		for (int q = 0; ((j + q) < (int)mObjects.size()) && (q < numQ); ++ q) 
+		for (int t = 0; t < q; ++ t) 
 		{
 			unsigned int pixelCount;
-					
+		
 			//-- reenable other state
-#if 1
+#if 0
+			bool available;
+
 			do 
 			{
-				glGetOcclusionQueryuivNV(mOcclusionQueries[q], GL_PIXEL_COUNT_AVAILABLE_NV, &pixelCount);
-					
-				if (pixelCount == 0) cout << "W";
+				available = mOcclusionQueries[t]->ResultAvailable();
+				
+				if (!available) cout << "W";
 			} 
-			while (!pixelCount);
+			while (!available);
 #endif
 
-			glGetOcclusionQueryuivNV(mOcclusionQueries[q], GL_PIXEL_COUNT_NV, &pixelCount);
-
-			if (pixelCount > 0)
-				outfile <<"o="<<j+q<<" q="<<mOcclusionQueries[q]<<" pc="<<pixelCount<<" ";
-			
-			mObjects[j + q]->mCounter += pixelCount;
+			pixelCount = mOcclusionQueries[t]->GetQueryResult();
+
+			//if (pixelCount > 0)
+			//	cout <<"o="<<j+q<<" q="<<mOcclusionQueries[q]->GetQueryId()<<" pc="<<pixelCount<<" ";
+			mObjects[j + t]->mCounter += pixelCount;
 		}
 
-		j += q;
-	}
-
-glFinish();
+		//j += q;
+	}
+#endif
+	//glFinish();
 	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
 	glDepthMask(GL_TRUE);
@@ -552,6 +609,7 @@
 
 void
-GlRendererBuffer::EvalRenderCostSample(
-									   RenderCostSample &sample
+GlRendererBuffer::EvalRenderCostSample(RenderCostSample &sample,
+									   const bool useOcclusionQueries,
+									   const int threshold
 									   )
 {
@@ -575,4 +633,5 @@
 	int i, j;
 
+	// reset object counters
 	ObjectContainer::const_iterator it, it_end = mObjects.end();
 
@@ -584,14 +643,10 @@
 	++ mFrame;
 
-	// either use occlusion queries or item buffer
-	bool useOcclusionQueries;
-	environment->GetBoolValue("RenderSampler.useOcclusionQueries", useOcclusionQueries);
-
-	//if (useOcclusionQueries) cout << "using occlusion queries" << endl;
-	//else cout << "using item buffer" << endl;
-	
 	//glCullFace(GL_FRONT);
 	glCullFace(GL_BACK);
-
+	glDisable(GL_CULL_FACE);
+	
+
+	// query all 6 directions for a full point sample
 	for (i = 0; i < 6; ++ i) 
 	{
@@ -601,8 +656,11 @@
 		glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
 		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+		//glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);	glDepthMask(GL_TRUE);
 		glDepthFunc(GL_LESS);
+
 		mUseFalseColors = true;
 
-		// the actual scene rendering
+		// the actual scene rendering fills the depth (for occlusion queries)
+		// and the frame buffer (for item buffer)
 		RenderScene();
 
@@ -616,4 +674,5 @@
 		}
          
+		// evaluate the sample
 		if (useOcclusionQueries) 
 		{
@@ -633,5 +692,5 @@
 	{
 		Intersectable *obj = *it;
-		if (obj->mCounter) 
+		if (obj->mCounter >= threshold) 
 		{
 			++ sample.mVisibleObjects;
@@ -640,12 +699,13 @@
 	}
 
-	outfile << "RS=" << sample.mVisibleObjects << " ";
-}
-
-
-void
-GlRendererBuffer::SampleRenderCost(
-								   const int n,
-								   vector<RenderCostSample> &samples
+	//cout << "RS=" << sample.mVisibleObjects << " ";
+}
+
+
+void
+GlRendererBuffer::SampleRenderCost(const int numSamples,
+								   vector<RenderCostSample> &samples,
+								   const bool useOcclusionQueries,
+								   const int threshold
 								   )
 {
@@ -655,47 +715,25 @@
 	  mPixelBuffer = new unsigned int[GetWidth()*GetHeight()];
   
+  // using 90 degree projection to capture 360 view with 6 samples
   SetupProjection(GetHeight(), GetHeight(), 90.0f);
 
-  samples.resize(n);
+  samples.resize(numSamples);
   halton.Reset();
   
-  // the number of queries simultanosly allocated
-  const int numQ = 400;
-  //const int numQ = 3;
-#if 1
-  for (int i = (int)mOcclusionQueries.size(); i < numQ; ++ i)
+  // the number of queries queried in batch mode
+  const int numQ = 500;
+  //const int numQ = (int)mObjects.size();
+  if (useOcclusionQueries)
   {
-	  unsigned int query;
-	  glGenOcclusionQueriesNV(1, &query);
-	  mOcclusionQueries.push_back(query);
-	  //mOcclusionQueries[i] = queries[i];
-  }
-#else
-  if ((int)mOcclusionQueries.size() < numQ)
+	  cout << "\ngenerating " << numQ << " queries ... ";
+	  OcclusionQuery::GenQueries(mOcclusionQueries, numQ);
+	  cout << "finished" << endl;
+  }
+
+  // sampling queries 
+  for (int i = 0; i < numSamples; ++ i)
   {
-	  cout << "allocating occ queries..." << endl;
-	
-	  unsigned int *queries = new unsigned int[numQ];
-	  
-	  // matt: ?
-	  for (int i = 0; i < numQ; ++ i)
-          queries[i] = 111;
-	
-	  glGenOcclusionQueriesNV(numQ, queries);
-	  mOcclusionQueries.resize(numQ);
-	  
-    
-	   for (int i = 0; i < numQ; ++ i)
-	   {
-		   mOcclusionQueries[i] = queries[i];
-	   }
-
-	   DEL_PTR(queries);
-  }
-#endif
-  
-  for (int i = 0; i < n; ++ i)
-  {
-	  EvalRenderCostSample(samples[i]);
+	  cout << ".";
+	  EvalRenderCostSample(samples[i], useOcclusionQueries, threshold);
   }
 
@@ -707,7 +745,5 @@
 void
 GlRendererBuffer::RandomViewPoint()
-{
-  
-  
+{ 
   // do not use this function since it could return different viewpoints for
   // different executions of the algorithm
@@ -770,10 +806,11 @@
   
   mUseFalseColors = false;
-
-  static int query = -1;
   unsigned int pixelCount;
 
-  if (query == -1)
-	glGenOcclusionQueriesNV(1, (unsigned int *)&query);
+  //static int query = -1;
+  //if (query == -1)
+//	  glGenOcclusionQueriesNV(1, (unsigned int *)&query);
+
+  OcclusionQuery query;
 
   if (mDetectEmptyViewSpace) {
@@ -789,9 +826,9 @@
 	glDisable( GL_CULL_FACE );
 	
-	glBeginOcclusionQueryNV(query);
+	query.BeginQuery();
 	
 	RenderScene();
 	
-	glEndOcclusionQueryNV();
+	query.EndQuery();
 	
 	// at this point, if possible, go and do some other computation
@@ -801,7 +838,5 @@
 	
 	// reenable other state
-	glGetOcclusionQueryuivNV(query,
-							 GL_PIXEL_COUNT_NV,
-							 &pixelCount);
+	pixelCount = query.GetQueryResult();
 	
 	if (pixelCount > 0)
@@ -842,5 +877,5 @@
 	mUseFalseColors = true;
 
-	glBeginOcclusionQueryNV(query);
+	query.BeginQuery();
 
 	SetupCamera();
@@ -848,12 +883,11 @@
 	RenderScene();
 	
-	glEndOcclusionQueryNV();
+	query.EndQuery();
 	
 
 	unsigned int pixelCount;
 	// reenable other state
-	glGetOcclusionQueryuivNV(query,
-							 GL_PIXEL_COUNT_NV,
-							 &pixelCount);
+	pixelCount = query.GetQueryResult();
+	
 	
 	pErrorPixels = ((float)pixelCount)/(GetWidth()*GetHeight());
@@ -1117,4 +1151,5 @@
 {
   ObjectContainer::const_iterator oi = mObjects.begin();
+
   for (; oi != mObjects.end(); oi++)
 	RenderIntersectable(*oi);
@@ -1902,5 +1937,5 @@
 
 	// create new queries if necessary
-	GenQueries((int)beam.mViewCells.size());
+	OcclusionQuery::GenQueries(sQueries, (int)beam.mViewCells.size());
 
 	// check whether any backfacing polygon would pass the depth test?
@@ -1919,9 +1954,11 @@
 	for (vit = beam.mViewCells.begin(); vit != vit_end; ++ vit)
 	{
-		glBeginOcclusionQueryNV(sQueries[queryIdx ++]);
+		sQueries[queryIdx ++]->BeginQuery();
 
 		RenderIntersectable(*vit);
 		
-		glEndOcclusionQueryNV();
+		sQueries[queryIdx]->EndQuery();
+
+		++ queryIdx;
 	}
 
@@ -1937,12 +1974,10 @@
 
 	queryIdx = 0;
-	unsigned int pixelCount;
 
 	for (vit = beam.mViewCells.begin(); vit != vit_end; ++ vit)
 	{
 		// fetch queries
-		glGetOcclusionQueryuivNV(sQueries[queryIdx ++],
-								 GL_PIXEL_COUNT_NV,
-								 &pixelCount);
+		unsigned int pixelCount = sQueries[queryIdx ++]->GetQueryResult();
+
 		if (pixelCount)
 			Debug << "view cell " << (*vit)->GetId() << " visible pixels: " << pixelCount << endl;
@@ -1991,23 +2026,4 @@
 	if (beam.mFlags & !Beam::STORE_OBJECTS)
 		beam.mObjects.clear();
-}
-
-
-void GlRendererBuffer::GenQueries(const int numQueries)
-{
-	if ((int)sQueries.size() < numQueries)
-	{
-		const int n = numQueries - (int)sQueries.size();
-		unsigned int *newQueries = new unsigned int[n];
-
-		glGenOcclusionQueriesNV(n, (unsigned int *)newQueries);
-
-		for (int i = 0; i < n; ++ i)
-		{
-			sQueries.push_back(newQueries[i]);
-		}
-
-		delete [] newQueries;
-	}
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dParserXerces.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dParserXerces.h	(revision 971)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dParserXerces.h	(revision 1001)
@@ -22,18 +22,20 @@
 
 
-struct ltstr
-{
-  bool operator()(const string &s1, const string &s2) const
-  {
-    return s1 < s2;
-  }
-};
-
-typedef map<string, Mesh *, ltstr> MeshDefinitions;
-typedef map<string, Material *, ltstr> MaterialDefinitions;
 
 class X3dParseHandlers : public HandlerBase
 {
 public:
+
+	// used for generating name / key pair
+	struct ltstr
+	{
+		bool operator()(const std::string &s1, const std::string &s2) const
+		{
+			return s1 < s2;
+		}
+	};
+
+	typedef map<string, int, ltstr> ResourceDefinitions;
+
   // -----------------------------------------------------------------------
   //  Constructors and Destructor
@@ -77,8 +79,10 @@
 
   SceneGraphNode *mCurrentNode;
-  Mesh *mCurrentMesh;
+ 
   vector<VertexIndexContainer> mCurrentVertexIndices;
   VertexContainer mCurrentVertices;
-  string mCurrentMeshName;
+
+  //string mCurrentMeshName;
+  Mesh *mCurrentMesh;
 
   Material *mCurrentMaterial;
@@ -89,13 +93,13 @@
 
   bool mUsingMeshDefinition;
+
   // stack of accumulated transformations
   TrafoStack mTransformations;
 
-  MaterialDefinitions mMaterialDefinitions;
-  MeshDefinitions mMeshDefinitions;
-
-  // TODO: for storing meshes
-  MeshContainer *mMeshes;
+  ResourceDefinitions mMaterialDefinitions;
+  ResourceDefinitions mMeshDefinitions;
+
   bool mIsMeshDefinition;
+
   // Handlers for X3D
   void
@@ -122,5 +126,7 @@
   /// transforms mesh using the given transformations
   void ApplyTransformations(TrafoStack trafos, Mesh *mesh) const;
-
+  void ApplyTransformations(TrafoStack trafos, TransformedMeshInstance *mi) const;
+
+  static int mUniqueMeshIdx;
 
   // -----------------------------------------------------------------------
@@ -200,5 +206,6 @@
 
   VertexIndexContainer mCurrentVertexIndices;
- 
+  VertexContainer mCurrentVertices;
+
   // Handlers for X3D
   void
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.cpp	(revision 991)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.cpp	(revision 1001)
@@ -3,4 +3,5 @@
 #include "MeshKdTree.h"
 #include "Triangle3.h"
+#include "ResourceManager.h"
 
 namespace GtpVisibilityPreprocessor {
@@ -432,8 +433,7 @@
 int
 Mesh::GetRandomVisibleSurfacePoint(Vector3 &point,
-																	 Vector3 &normal,
-																	 const Vector3 &viewpoint,
-																	 const int maxTries
-																	 )
+								   Vector3 &normal,
+								   const Vector3 &viewpoint,
+								   const int maxTries)
 {
   Plane3 plane;
@@ -463,50 +463,4 @@
 
 
-int
-MeshInstance::CastRay(
-					  Ray &ray
-					  )
-{
-  int res = mMesh->CastRay(ray, this);
-  return res;
-}
-
-int
-MeshInstance::CastRay(
-					  Ray &ray,
-					  const vector<int> &faces
-					  )
-{
-  return mMesh->CastRayToSelectedFaces(ray, faces, this);
-}
-
-
-
-int
-MeshInstance::GetRandomSurfacePoint(Vector3 &point, Vector3 &normal)
-{
-  return mMesh->GetRandomSurfacePoint(point, normal);
-}
-
-int
-MeshInstance::GetRandomVisibleSurfacePoint(Vector3 &point,
-																					 Vector3 &normal,
-																					 const Vector3 &viewpoint,
-																					 const int maxTries
-																					 )
-{
-	return mMesh->GetRandomVisibleSurfacePoint(point, normal, viewpoint, maxTries);
-}
-
-
-int
-TransformedMeshInstance::GetRandomSurfacePoint(Vector3 &point, Vector3 &normal)
-{
-  int index = mMesh->GetRandomSurfacePoint(point, normal);
-  point = mWorldTransform*point;
-  normal = TransformNormal(mWorldTransform, normal);
-  return index;
-}
-
 Plane3
 Mesh::GetFacePlane(const int faceIndex)
@@ -554,8 +508,211 @@
 }
 
-int
-TransformedMeshInstance::CastRay(
-								 Ray &ray
-								 )
+
+void
+Mesh::AddTriangle(const Triangle3 &triangle)
+{
+  int index = (int)mVertices.size();
+
+  for (int i=0; i < 3; i++) {
+    mVertices.push_back(triangle.mVertices[i]);
+  }
+  
+  AddFace(new Face(index + 0, index + 1, index + 2) );
+}
+
+void
+Mesh::AddRectangle(const Rectangle3 &rect)
+{
+  int index = (int)mVertices.size();
+
+  for (int i=0; i < 4; i++) {
+    mVertices.push_back(rect.mVertices[i]);
+  }
+  
+  AddFace(new Face(index + 0, index + 1, index + 2, index + 3) );
+}
+
+void
+Mesh::AssignRandomMaterial()
+{  
+	mMaterial = MaterialManager::GetSingleton()->CreateResource();
+  
+	Material randMat = RandomMaterial();
+
+	mMaterial->mDiffuseColor = randMat.mDiffuseColor;
+	mMaterial->mSpecularColor = randMat.mSpecularColor;
+	mMaterial->mAmbientColor = randMat.mAmbientColor;
+}
+
+
+Mesh *CreateMeshFromBox(const AxisAlignedBox3 &box)
+{
+	Mesh *mesh = MeshManager::GetSingleton()->CreateResource();
+
+	// add 8 vertices of the box
+	const int index = (int)mesh->mVertices.size();
+	
+	for (int i=0; i < 8; ++ i) 
+	{
+        Vector3 v;
+		box.GetVertex(i, v);
+		mesh->mVertices.push_back(v);
+	}
+
+	mesh->AddFace(new Face(index + 0, index + 1, index + 3, index + 2) );
+	mesh->AddFace(new Face(index + 0, index + 2, index + 6, index + 4) );
+	mesh->AddFace(new Face(index + 4, index + 6, index + 7, index + 5) );
+  
+	mesh->AddFace(new Face(index + 3, index + 1, index + 5, index + 7) );
+	mesh->AddFace(new Face(index + 0, index + 4, index + 5, index + 1) );
+	mesh->AddFace(new Face(index + 2, index + 3, index + 7, index + 6) );
+  
+	return mesh;
+}
+
+
+Mesh::Mesh(const int id, const int vertices, const int faces):
+mFaces(),
+mMaterial(NULL),
+mKdTree(NULL),
+mVertices(),
+mIsConvex(false),
+mIsWatertight(false),
+mId(id)
+{
+    mVertices.reserve(vertices);
+    mFaces.reserve(faces);
+}
+
+
+Mesh::Mesh(const int id): 
+mId(id), mVertices(), mFaces(), mMaterial(NULL), mKdTree(NULL) 
+{}
+
+
+// apply transformation to each vertex
+void Mesh::ApplyTransformation(const Matrix4x4 &m)
+{
+	VertexContainer::iterator it, it_end = mVertices.end();
+
+	for (it = mVertices.begin(); it != it_end; ++ it)
+	{
+		(*it) = m * (*it);        
+	}
+}
+
+
+Mesh::Mesh(const Mesh &rhs)
+{
+	mVertices = rhs.mVertices;
+	mFaces.reserve(rhs.mFaces.size());
+	mId = rhs.mId;
+
+	FaceContainer::const_iterator it, it_end = rhs.mFaces.end();
+
+	for (it = rhs.mFaces.begin(); it != it_end; ++ it)
+	{
+		Face *face = *it;
+		mFaces.push_back(new Face(*face));
+	}
+}
+
+
+Mesh& Mesh::operator=(const Mesh& m) 
+{
+    if (this == &m) 
+		return *this;
+ 
+	CLEAR_CONTAINER(mFaces);
+
+	mVertices = m.mVertices;
+	mFaces.reserve(m.mFaces.size());
+	//mId = m.mId;
+
+	FaceContainer::const_iterator it, it_end = m.mFaces.end();
+
+	for (it = m.mFaces.begin(); it != it_end; ++ it)
+	{
+		Face *face = *it;
+		mFaces.push_back(new Face(*face));
+	}
+
+	return *this;
+}
+
+
+
+/********************************************************/
+/*	    		MeshInstance implementation             */
+/********************************************************/
+
+int
+MeshInstance::CastRay(
+					  Ray &ray
+					  )
+{
+  int res = mMesh->CastRay(ray, this);
+  return res;
+}
+
+int
+MeshInstance::CastRay(
+					  Ray &ray,
+					  const vector<int> &faces
+					  )
+{
+  return mMesh->CastRayToSelectedFaces(ray, faces, this);
+}
+
+
+
+int
+MeshInstance::GetRandomSurfacePoint(Vector3 &point, Vector3 &normal)
+{
+  return mMesh->GetRandomSurfacePoint(point, normal);
+}
+
+int
+MeshInstance::GetRandomVisibleSurfacePoint(Vector3 &point,
+										   Vector3 &normal,
+										   const Vector3 &viewpoint,
+										   const int maxTries)
+{
+	return mMesh->GetRandomVisibleSurfacePoint(point, normal, viewpoint, maxTries);
+}
+
+
+void MeshInstance::SetMaterial(Material *mat)
+{
+	mMaterial = mat;
+}
+
+Material *MeshInstance::GetMaterial() const
+{
+	return mMaterial;
+}
+
+
+/*************************************************************/
+/*	  		TransformedMeshInstance implementation		     */
+/*************************************************************/
+
+TransformedMeshInstance::TransformedMeshInstance(Mesh *mesh): 
+MeshInstance(mesh)
+{
+    mWorldTransform = IdentityMatrix();
+}
+
+
+int TransformedMeshInstance::GetRandomSurfacePoint(Vector3 &point, Vector3 &normal)
+{
+  int index = mMesh->GetRandomSurfacePoint(point, normal);
+  point = mWorldTransform*point;
+  normal = TransformNormal(mWorldTransform, normal);
+  return index;
+}
+
+
+int TransformedMeshInstance::CastRay(Ray &ray)
 {
   ray.ApplyTransform(Invert(mWorldTransform));
@@ -567,59 +724,27 @@
 
 
-void
-Mesh::AddTriangle(const Triangle3 &triangle)
-{
-  int index = (int)mVertices.size();
-
-  for (int i=0; i < 3; i++) {
-    mVertices.push_back(triangle.mVertices[i]);
-  }
-  
-  AddFace(new Face(index + 0, index + 1, index + 2) );
-}
-
-void
-Mesh::AddRectangle(const Rectangle3 &rect)
-{
-  int index = (int)mVertices.size();
-
-  for (int i=0; i < 4; i++) {
-    mVertices.push_back(rect.mVertices[i]);
-  }
-  
-  AddFace(new Face(index + 0, index + 1, index + 2, index + 3) );
-}
-
-void
-Mesh::AssignRandomMaterial()
-{
-  if (!mMaterial)
-	mMaterial = new Material;
-  *mMaterial = RandomMaterial();
-
-}
-
-
-Mesh *CreateMeshFromBox(const AxisAlignedBox3 &box)
-{
-	Mesh *mesh = new Mesh;
-  // add 8 vertices of the box
-  int index = (int)mesh->mVertices.size();
-  for (int i=0; i < 8; i++) {
-    Vector3 v;
-    box.GetVertex(i, v);
-    mesh->mVertices.push_back(v);
-  }
-  
-  mesh->AddFace(new Face(index + 0, index + 1, index + 3, index + 2) );
-  mesh->AddFace(new Face(index + 0, index + 2, index + 6, index + 4) );
-  mesh->AddFace(new Face(index + 4, index + 6, index + 7, index + 5) );
-  
-  mesh->AddFace(new Face(index + 3, index + 1, index + 5, index + 7) );
-  mesh->AddFace(new Face(index + 0, index + 4, index + 5, index + 1) );
-  mesh->AddFace(new Face(index + 2, index + 3, index + 7, index + 6) );
-  
-  return mesh;
-}
-
-}
+void TransformedMeshInstance::ApplyWorldTransform(const Matrix4x4 &m)
+{
+	mWorldTransform = m * mWorldTransform;
+}
+
+
+void TransformedMeshInstance::LoadWorldTransform(const Matrix4x4 &m)
+{
+	mWorldTransform = m;
+}
+
+
+void TransformedMeshInstance::GetWorldTransform(Matrix4x4 &m)
+{
+	m = mWorldTransform;
+}
+
+
+AxisAlignedBox3 TransformedMeshInstance::GetBox() 
+{
+    return Transform(mMesh->mBox, mWorldTransform);
+}
+
+
+}
